program LAN;

uses crt,elasp,cmdln, display, graphic;
var
  cstr:string;
  key:char;
  i:longint;
  ub1,ub2,ub3,ub4:byte;
begin

clrscr;
iniCmdDisplay;
writeln('Logic Analyser @ RS232');
writeln('');
writeln('Allocating 520KB Memory On Heap...');
if not getLabMem then begin
 writeln('shift system to High mem!, quit fileManager etc!');
 halt(1);
end;


for i:=0 to 5000 do begin
  if (i mod 28) <6 then ub1:=$20 else ub1:=0;
  if (i mod 13) <30 then ub2:=$80 else ub2:=0;
  if (i mod 7) <15 then ub3:=$10 else ub3:=0;
  if (i mod 24) <3 then ub4:=$40 else ub4:=0;
  ub1:=ub1 or ub2 or ub3 or ub4;
  wrLabSamp(i,ub1);
  ub1:=0;
end;

{ initialization }
SPBA:= $2F8;
TrigSource:=_ts_CH1;
TrigEdge:= _te_falling;
SD:=5;
Generator:=0;

repeat
  writeStat;
  readln(cstr);
  cmd(cstr);
  case c of
  _ts:begin
        OldTrig:=0;CurTrig:=0;
        case xint[0] of
          1:TrigSource:= _ts_CH1;
          2:TrigSource:= _ts_CH2;
          3:TrigSource:= _ts_CH3;
          4:TrigSource:= _ts_CH4;
        else
         writeln('Constant Out of range');
        end;
      end;
  _te:begin
        if xstr[0]<>'r' then begin
          if xstr[0]<>'f' then begin
            writeln('Unrecognized Edge (falling=f, rising=r)');
          end
          else begin
            TrigEdge:= _te_falling;
          end;
        end
        else begin
          TrigEdge:= _te_rising;
        end;
      end;
  _sd:begin
        if (xint[0]<0) or (xint[0]>32000) then writeln('SD out of range')
        else begin
          SD:= xint[0];
        end;
      end;
  _gen:begin
        if (xint[0]<0) or (xint[0]>1) then writeln('Constant Out of Range')
       else begin
         Generator:= byte(xint[0]);
       end;
      end;
  _go:begin
        curTrig:= byte((chs and TrigSource)=TrigSource);
        OldTrig:=CurTrig;
        writeln('Clearing Memory Blocks');
        ClearBuf;
        writeln('Waiting for Trigger Condition...(q=break)');
        repeat
          {if keypressed then key:=readkey;}
        until (key='q') or trigger;
        key:=#0;
        writeln('Sampling...');

        if Go then writeln('Done.') else writeln('Sampling Interrupted');

      end;
  _scope:begin
        iniGraph;
        draw;
        closeg;
      end;
  _ich:begin
       NOT_CH:= not NOT_CH;
      end;
  end;
until c=_exit;

writeln('Disposing used memory...');
freeLabMem;
writeln('## LAN ## Logic Analyser from Cyber. http://asyncbrain.baf.cz');
end.